.cache: &cache
  key:
    files:
      - $TF_ROOT/.terraform.lock.hcl
  paths:
    - $TF_ROOT/.terraform
  policy: pull

default:
  image: registry.gitlab.com/dependabot-gitlab/ci-images/helm-terraform:3.12-1.4
  interruptible: true
  cache: *cache

variables:
  TF_STATE_NAME: production
  TF_ROOT: $CI_PROJECT_DIR/deploy
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${TF_STATE_NAME}
  TF_VAR_image_registry: $APP_IMAGE_NAME
  TF_VAR_image_tag: $CURRENT_TAG
  TF_VAR_gitlab_access_token: $GITLAB_ACCESS_TOKEN
  TF_VAR_github_access_token: $GITHUB_ACCESS_TOKEN
  TF_VAR_dependabot_host: dependabot-gitlab.com
  TF_VAR_log_level: info
  GOOGLE_CLOUD_KEYFILE_JSON: $KEYFILE_DEPENDABOT_GITLAB

# ======================================================================================================================
# Jobs
# ======================================================================================================================
.init:
  stage: .pre
  script:
    - gitlab-terraform init
  cache:
    <<: *cache
    policy: pull-push

.build:
  stage: build
  resource_group: $TF_STATE_NAME
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  artifacts:
    reports:
      terraform: $TF_ROOT/plan.json

.fmt:
  stage: static analysis
  script:
    - gitlab-terraform fmt

.validate:
  stage: static analysis
  script:
    - gitlab-terraform validate

.deploy:
  stage: deploy
  resource_group: $TF_STATE_NAME
  environment:
    name: $TF_STATE_NAME
    url: https://$TF_VAR_dependabot_host
  script:
    - gitlab-terraform plan
    - gitlab-terraform apply
  interruptible: false
